import Bladex
import EnemyTypes
import Actions
import ItemTypes



###### Not all these enemies are used in the map:
###### Some Aura and Camera functions are included here too:


############ Aura FX on player/enemy using any Particle type (effect):

def DeathAppears(PersonName,effect):
	time=Bladex.GetTime()
	aura=Auras.MakeAura(PersonName,0.8,   ( 50, 1.0 , 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))
	aura.Data.AddEvent(time+0.4,          (150, 0.5 , 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))
	aura.Data.AddEvent(time+0.8,          (200, 0.01, 0.0, 0, 0, 0), (), (), (2,  0.9, 0.9, 0.0, 0.9, 0.0  ,  0.9, 0.9, 0.0, 0.9, 0.8))

	wps=Bladex.CreateEntity(PersonName+"WPS", "Entity Particle System Dperson", 0.0, 0.0, 0.0)
	wps.PersonName=PersonName
	wps.ParticleType=effect
	wps.Time2Live=32
	wps.RandomVelocity=2.0
	wps.Velocity=0,0,0
	wps.NormalVelocity=20
	wps.YGravity=0
	wps.DeathTime=Bladex.GetTime()+0.8
	wps.PPS=1024
############################################################################################





########### Create Minotaur Guardian and weapon (Mazapiedra) ####################

o=Bladex.CreateEntity("StoneHammer","Mazapiedra",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs (o)
pers=Bladex.CreateEntity("Min1","Minotaur",18000, -1500, 20000,"Person")
pers.Angle=3.5
pers.Level=6
Actions.TakeObject(pers.Name,o.Name)
pers.Blind       = 1
pers.Deaf        = 1
EnemyTypes.EnemyDefaultFuncs(pers)
pers.SetOnFloor()
darfuncs.HideBadGuy("Min1")



###################### Skeletons

#################### Unhide second three skeletons with balls of fire:



###### Unhide first skeleton with puff of smoke and make him attack the player:
###### Unhide Orc in ball of flames and Minotaur

def unhideskel11():
	darfuncs.UnhideBadGuy("Skeleton11")
	DeathAppears("Skeleton11","DeathCloud")
	darfuncs.UnhideBadGuy("Skeleton12")
	DeathAppears("Skeleton12","LargeFire")
	darfuncs.UnhideBadGuy("Min1")
	o=Bladex.GetEntity("Skeleton11")
	o.SetActiveEnemy("Player1")

######### Define sectors that will make skeleton appear when entered:

darfuncs.EnterSecEvent(-22000, -1000, 0, unhideskel11)
#darfuncs.EnterSecEvent(26000, -1000, 0, unhideskel13)

############## Create and hide 5 skeletons:

pers=Bladex.CreateEntity("Skeleton11","Skeleton",5000,-1000,-3000,"Person")
pers.Angle=1
pers.Level=17
o=Bladex.CreateEntity("newskw1","HookSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh1","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.Blind       = 1
pers.Deaf        = 1
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton11")
#############

pers=Bladex.CreateEntity("Skeleton12","Ork",18000,-1000,-20000,"Person")
pers.Angle=6
pers.Level=17
o=Bladex.CreateEntity("newskw2","HookSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh2","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.Blind       = 1
pers.Deaf        = 1
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton12")

pers=Bladex.CreateEntity("Skeleton14","Skeleton",66000,-1500,3000,"Person")
pers.Angle=4
pers.Level=19
o=Bladex.CreateEntity("newskw4","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
EnemyTypes.EnemyDefaultFuncs(pers)
pers.Blind       = 0
pers.Deaf        = 0
pers.SetOnFloor()

##########################################################################################

##### Camera retreat on Knight death function: 

def Mov6():
	Bladex.ActivateInput()
	darfuncs.BackPlayer()
	en1=Bladex.GetEntity("Skeleton14")
	en1.Blind=0
	en1.Deaf=0	

def Mov5():
	o=Bladex.GetEntity("Player1")
	o.Position=-32000,-1300,0
	cam=Bladex.GetEntity("Camera")
	Point=-54000,-1800,0
	Target=66000,-1800,0
	Time=3
	auxi1=cam.Position
	auxi2=cam.TPos
	AuxFuncs.MoveCamFromTo(auxi1[0], auxi1[1], auxi1[2], Point[0], Point[1], Point[2], auxi2[0],auxi2[1], auxi2[2],Target[0], Target[1], Target[2], Time, Mov6)

def Roar():
	o=Bladex.GetEntity("Player1")
	sound3=Bladex.CreateSound("roar.wav", "SndRoar")
	sound3.Volume=1
	sound3.MinDistance=10000.0
	sound3.MaxDistance=100000.0
	sound3.Play(o.Position[0], o.Position[1], o.Position[2], 0)

def Mov4(Point,Target,Time):
	cam=Bladex.GetEntity("Camera")
	auxi1=cam.Position
	auxi2=cam.TPos
	AuxFuncs.MoveCamFromTo(auxi1[0], auxi1[1], auxi1[2], Point[0], Point[1], Point[2], auxi2[0],auxi2[1], auxi2[2],Target[0], Target[1], Target[2], Time, Mov5)
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.8, Roar, ())

def SkelRun():
	en1=Bladex.GetEntity("Skeleton14")
	en1.GoToJogging=1
	Point=44000,-1800,0
	Target=66000,-1800,0
	Time=3
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.4, Mov4, (Point,Target,Time))

def SkelAttack(entity):
	en1=Bladex.GetEntity("Skeleton14")
	Actions.TurnToFaceEntity("Skeleton14", "Player1")
#	en1.Angle = 2
	en1.Blind=1
	en1.Deaf=1
	en1.GoToJogging=0
	en1.GoTo(32000,-1800,-1000)
	Bladex.AddScheduledFunc(Bladex.GetTime()+3.5, SkelRun, ())

def Knight1DeadFunc(entity):
	SkelAttack(entity)

#######################################################################################

pers=Bladex.CreateEntity("Knight1","Knight_Traitor",65000,-1500,0,"Person")
pers.Angle=2
pers.Level=17
o=Bladex.CreateEntity("newskw3","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh3","Escudo6",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.Blind       = 1
pers.Deaf        = 1
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
pers.Life=1
pers.ImDeadFunc = Knight1DeadFunc
#darfuncs.HideBadGuy("Knight1")
##########



###########
pers=Bladex.CreateEntity("Skeleton15","Skeleton",60000,-1500,0,"Person")
pers.Angle=1
pers.Level=17
o=Bladex.CreateEntity("newskw5","DoubleSword",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
o=Bladex.CreateEntity("newsksh5","Escudo7",0,0,0,"Weapon")
ItemTypes.ItemDefaultFuncs(o)
Actions.TakeObject(pers.Name,o.Name)
pers.Blind       = 1
pers.Deaf        = 1
pers.SetOnFloor()
EnemyTypes.EnemyDefaultFuncs(pers)
darfuncs.HideBadGuy("Skeleton15")
