import Bladex
import Objects
import ItemTypes
import Sounds
import Auras
import GameText
import MenuText
import darfuncs
import AuxFuncs
import pocimac

################ Set up On-Screen text functions:
def GetText(s):
	return MenuText.GetMenuText(s)
def ClearText():
	GameText.ClearText()

##########################################################################################

################ Allow player to kill selected enemy by pressing "K"

def KillSelected():
	char = Bladex.GetEntity("Player1")
	if char.Data.selected_enemy:
		en = Bladex.GetEntity(char.Data.selected_enemy[0])
		if en:
			en.Life = 0

Bladex.AddInputAction("KillSelected", 0)
Bladex.AddBoundFunc("KillSelected", KillSelected)
Bladex.AssocKey("KillSelected", "Keyboard", "K", 1)

##########################################################################################
def ReturnCam():
	darfuncs.BackPlayer()

Bladex.AddInputAction("ReturnCam", 0)
Bladex.AddBoundFunc("ReturnCam", ReturnCam)
Bladex.AssocKey("ReturnCam", "Keyboard", "R", 1)


############### Player Aura and Invincibility triggered by entering pool sector:
############### Mortality removes invincibility in 30 seconds.
Count=0
invin=0

def Mortality(entity):
	pers=Bladex.GetEntity("Player1")
	pers.Data.Invincibility = 0        # REMOVE INVINCIBILITY
	global invin
	invin=0


def Fading(entity):
	aura= Auras.MakeAura (entity,5,(80, 1, 1, 0,0,1), (),(),(2, 0.9, 0.4, 0.2, 0.6, 0.0, 0.8, 0.1, 0.1, 0.0, 0.6))
	Bladex.AddScheduledFunc(Bladex.GetTime()+5,Mortality,(entity))
	ClearText()
	GameText.WriteTextAux(GetText("Invulnerability fading"), 5.0, 255,170,10,0,30,[])



def PlayerAura(sector,entity):
	global invin
	if (entity == "Player1" and invin==0):
		invin=1
		aura= Auras.MakeAura (entity,25,(80, 1, 1, 0,0,1), (),(),(2, 0.2, 0.2, 1.0, 0.6, 0.0, 0.3, 1.0, 0.5, 0.0, 0.6))
		pers=Bladex.GetEntity(entity)
		pers.Data.Invincibility = 3 # MAKE PLAYER INVINCIBLE
		pers.Life=CharStats.GetCharMaxLife(pers.Kind, pers.Level) 
		pocimac.RestoreWoundsToLifeLevel(pers.Name)
		Bladex.AddScheduledFunc(Bladex.GetTime()+25,Fading,(entity,)) 
		ClearText()
		GameText.WriteTextAux(GetText("Invulnerability"), 5.0, 255,170,10,0,30,[])



sect2 = Bladex.GetSector(-6000,-500,12000)
sect2.OnEnter = PlayerAura

###########################################################################################




###########################################################################################


############ Create orb for Dragon missile:

o=Bladex.CreateEntity("Doom","Orbe",48000, -9000, 0,"Weapon")
o.Scale=0.75
o.SelfIlum=6
o.Orientation=0.7,0.7,0,0
o.Static=1
ItemTypes.ItemDefaultFuncs(o)

###################################################

def FireBallXL5(entity,effect):
	aura= Auras.MakeAura ("Dragon1",1,(80, 1, 1, 0,0,1), (),(),(2, 0.9, 0.9, 0.0, 0.6, 0.0, 0.5, 0.1, 0.2, 0.0, 0.6))
	esq = Bladex.GetEntity(entity)
	o=Bladex.GetEntity("Player1")
	sound2=Bladex.CreateSound("wing.wav", "SndFireball")
	sound2.Volume=1
	sound2.MinDistance=1000000.0
	sound2.MaxDistance=1000000.0
	sound2.Play(o.Position[0], o.Position[1], o.Position[2], 0)
	FireBall = Bladex.CreateEntity("Flash"+str(entity), "Entity Particle System Dobj", esq.Position[0],esq.Position[1],esq.Position[2])
	FireBall.ObjectName     = "Doom"
	FireBall.ParticleType   = effect
	FireBall.YGravity       = -2000 # -1000
	FireBall.Friction       = 0
	FireBall.PPS            = 1024 # 2024
	FireBall.Velocity       = 0,800, 0 # 0,800,0
	FireBall.Time2Live      = 30 # 30
	FireBall.RandomVelocity = 15 # 35
	FireBall.DeathTime=Bladex.GetTime()+1.0


########################################################################


############## Dragon attack:

def CoolFX(entity,effect):
	o = Bladex.GetEntity(entity)
	FX = Bladex.CreateEntity("FXO"+str(tmx), "Entity Particle System Dobj",o.Position[0], o.Position[1], o.Position[2])
	FX.ObjectName=entity
	FX.ParticleType   = effect
	FX.YGravity       = -600 # -1000
	FX.Friction       = 0.01
	FX.PPS            = 256 # 1024
	FX.Velocity       = 0, 0, 0 # 0,800,0
	FX.Time2Live      = 30 #30 #60
	FX.NormalVelocity=0.1 #-2.0
	FX.RandomVelocity = 10 #20 #65
	FX.DeathTime=Bladex.GetTime()+1

chek=0

def NewBolt():
	global chek
	chek=0

def Explode():
	CoolFX("Doom","LargeFire")

def DragonFire(sector,entity):
	if entity == "Player1":
		sect3.OnEnter = ""
		o=Bladex.GetEntity("Dragon1")
		p=Bladex.GetEntity("Player1")	
		tmx=Bladex.GetTime()
		sound3=Bladex.CreateSound("wing.wav", "SndObjDoom")
		sound3.Volume=1
		sound3.Play(o.Position[0], o.Position[1], o.Position[2], 0)
		dinobj = Objects.CreateDinamicObject("Doom")
		Objects.DisplaceObjectFromTo(dinobj, (o.Position[0],o.Position[1],o.Position[2]), ((p.Position[0]-(o.Position[0]-p.Position[0])),(p.Position[1]-(o.Position[1]-p.Position[1])),(p.Position[2]-(o.Position[2]-p.Position[2]))), 25000, 25000, "", "", "", "", "", "FireBallXL5",("Doom","LargeFire"))
		FireBallXL5("Doom","LargeFire")
		Bladex.AddScheduledFunc(Bladex.GetTime()+5,DragonFire,(sector,entity)) 

sect3 = Bladex.GetSector(27000,-500,0)
sect3.OnEnter = DragonFire






###########################################################################################

################### Lightning Bolt ##############

###################### Turn off bolt ray
def NoBolt():
	global num
	for x in range(num):
		kill_ray=Bladex.GetEntity("Ray"+str(x))
		kill_ray.Active = 0

###################### Create bolt with sound and make aura on target: 
num=0
def ShockBolt(entity):
	global num
	o=Bladex.GetEntity(entity)
	sound=Bladex.CreateSound("..\\tutor\\dadada.wav", "BoltSnd")
	sound.Volume=1
	sound.MinDistance=10000.0
	sound.MaxDistance=100000.0
	sound.Play(o.Position[0], o.Position[1], o.Position[2], 0)
	r=Bladex.CreateEntity("Ray"+str(num), "Entity ElectricBolt", -6000, -3000,0)
	r.Target           = o.Position[0], o.Position[1], o.Position[2]
	r.MaxAmplitude     = 80
	r.MinSectorLength  = 100000
	r.CoreGlowColor=245, 245, 255
	r.InnerGlowColor=100, 100, 250
	r.OuterGlowColor=0.0, 0.0, 255
	r.Active           = 1
	r.Damage           = 1
	aura= Auras.MakeAura (o.Name,0.5,(80, 1, 1, 0,0,1), (),(),(2, 0.6, 0.7, 1.0, 0.6, 0.4, 0.4, 1.0, 0.5, 0.0, 0.6))


################################### Turn off ray after 0.1 seconds
	Bladex.AddScheduledFunc(Bladex.GetTime()+0.1,NoBolt,()) 
	num=num+1

################### Add Flash and Earth tremor if player is hit:
	if o.Name == "Player1":
		AuxFuncs.FadeFrom(0.15,0.0,155,155,255)
		darfuncs.Temblores(1.0,10)
		o.Move(-200,-100,0)
###########################################################################################


def Lightning(sector,entity):
		ShockBolt(entity)

############ Define sectors that will trigger lightning bolt when entered:

sect10 = Bladex.GetSector(-15500,-500,0)
sect10.OnEnter = Lightning

sect13 = Bladex.GetSector(-12500,-500,0)
sect13.OnEnter = Lightning

sect16 = Bladex.GetSector(-9500,-500,0)
sect16.OnEnter = Lightning

sect19 = Bladex.GetSector(-6500,-500,0)
sect19.OnEnter = Lightning

sect22 = Bladex.GetSector(-3500,-500,0)
sect22.OnEnter = Lightning

sect25 = Bladex.GetSector(-500,-500,0)
sect25.OnEnter = Lightning

sect29 = Bladex.GetSector(3500,-500,0)
sect29.OnEnter = Lightning
